/*
 * echo_udp -- echo-service mit TCP
 * 
 * (C) 1998 Jrgen Koneczny
*/


#include <stdio.h>
#include	<string.h>

#include	<atarierr.h>

#include	<socket.h>
#include <sockinit.h>
#include	<in.h>
#include <netdb.h>
#include	<sfcntl.h>

#define	REC_LEN	128


void	main( int argc, char *argv[] )
{
	servent	*se;
	hostent	*he;
	sockaddr_in	sin;
	char	*msg = "Hallo Echo\n";
	char	rec[REC_LEN];
	
	int	c = 1, ret, sock;

	if(( ret = sock_init()) != E_OK )
	{
		switch( ret )
		{
			case SE_NINSTALL:
				printf( "gethost: SOCKETS not installed\n" );
				break;
			case SE_NSUPP:
				printf( "gethost: SOCKETS.PRG is too old\n" );
				break;
		}
		return;
	}

	if( argc==1 )
	{
		printf( "no Host\n" );
		return;
	}

	/* Portnummer fr Echo-Service (TCP) ermitteln */
	if(( se = getservbyname( "echo", "tcp" )) == NULL )
	{
		printf( "unknown service echo\n" );
		return;
	}

	sin.sin_family = AF_INET;
	sin.sin_port = se->s_port;

	while( c < argc )
	{
		if(( he = gethostbyname( argv[c] )) != NULL )
		{
			if( he->h_addr )
			{
				sin.sin_addr = *( unsigned long *) he->h_addr;

				if(( sock = socket( AF_INET, SOCK_STREAM, IPPROTO_IP )) < 0 )
					printf( "error creating socket: %i\n", sock );
				
				else
				{
					/* Verbindung zum entfernten Rechner herstellen */
					if(( ret = connect( sock, &sin, ( int ) sizeof( sockaddr_in ))) != E_OK )
						printf( "error connecting host: %i\n", ret );

					/* Nachricht in Socket schreiben */
					else	if(( ret = send( sock, msg,( int ) strlen( msg ), 0 )) < 0 )
						printf( "error writing message: %i\n", ret );

					/* Nachricht aus Socket lesen */
					else	if(( ret =( int ) recv( sock, rec, REC_LEN, 0 )) < 0 )
						printf( "error receiving message: %i\n", ret );

					else	if( ret == 0 )
						printf( "nothing received\n" );

					else	if( ret > 0 )
					{
						rec[ret] = 0;
						printf( "%s", rec );
					}

					/* Verbindung zum entfernten Rechner beenden */
					shutdown( sock, 2 );

					/* Socket schlieen */
					sclose( sock );
				}
			}
			else
				printf( "%s was not resolve to an IP address\n" );
		}
		else
			printf( "unknown host %s\n", argv[c] );
		c++;
	}
}