/*
 * gethost.c -- Hostnamen in IP-Adresse auflsen
*/


#include	<stdio.h>

#include	<atarierr.h>

#include	<sockinit.h>
#include	<inet.h>
#include	<netdb.h>


void	main( int argc, char *argv[] )
{
	hostent	*he;
	int	c = 1, n, ret;

	/* Socket-Interface von IConnect initalisieren. */
	if(( ret = sock_init()) != E_OK )
	{
		switch( ret )
		{
			case SE_NINSTALL:
				printf( "gethost: SOCKETS not installed\n" );
				break;
			case SE_NSUPP:
				printf( "gethost: SOCKETS.PRG is too old\n" );
				break;
		}
		return;
	}

	while( c < argc )
	{
		if(( he = gethostbyname( argv[c] )) != NULL )
		{
			/* Offizieller Hostname */
			printf( "%s\n", he->h_name );

			/* alternative Hostnamen */
			n = 0;
			while( he->h_aliases[n] )
				printf( "alias: %s\n", he->h_aliases[n++] );
			
			/* IP-Adresse als 4-Byte-Darstellung ausgeben */
			n = 0;
			while( he->h_addr_list[n] )
				printf( "IP: %s\n", inet_ntoa( *( unsigned long* )( he->h_addr_list[n++] )));
		}
		else
			printf( "Not found.\n" );
		c++;
	}
}