/*
 * qotd -- 'Quote of the Day'-Daemon
 * 
 * (C) 1998 Jrgen Koneczny
*/


#include <stdio.h>
#include	<string.h>

#include	<atarierr.h>

#include	<socket.h>
#include <sockinit.h>
#include	<sockerr.h>
#include	<in.h>
#include <netdb.h>
#include	<sfcntl.h>


void	main( void )
{
	sockaddr_in	sin, sa;
	servent	*se;
	char	*msg = "Live is wonderful, isn't it?\n";
	int	len_s = ( int ) sizeof( sockaddr_in ), ret, s, sock;

	if(( ret = sock_init()) != E_OK )
	{
		switch( ret )
		{
			case SE_NINSTALL:
				printf( "quotd: SOCKETS not installed\n" );
				break;
			case SE_NSUPP:
				printf( "quotd: SOCKETS.PRG is too old\n" );
				break;
		}
		return;
	}

	/* Portnummer fr qotd-Service (TCP) ermitteln */
	if(( se = getservbyname( "qotd", "tcp" )) == NULL )
	{
		printf( "unknown service qotd\n" );
		return;
	}

	sin.sin_family = AF_INET;
	sin.sin_port = se->s_port;

	/* Socket erzeugen */
	if(( sock = socket( AF_INET, SOCK_STREAM, IPPROTO_TCP )) < 0 )
	{
		printf( "error creating socket: %i\n", sock );
		return;
	}
	/* Socket an lokalen Port binden */
	else	if(( ret = bind( sock, &sin, ( int ) sizeof( sockaddr_in ))) != E_OK )
	{
		printf( "error bind: %i\n", ret );
		sclose( sock );
		return;
	}
	/* Warteschlange fr eingehende Verbindungen einrichten */
	else	if(( ret = listen( sock, 10 )) != E_OK && ret != EISCONN )
	{
		printf( "error listen: %i\n", ret );
		sclose( sock );
		return;
	}

	for(;;)
	{
		/* Auf eingehende Verbindung warten */
		if(( s = accept( sock, &sa, &len_s )) < 0 )
		{
			printf( "error accept: %i\n", s );
			break;
		}
		/* Nachricht an Client senden */
		else	if(( ret = swrite( s, msg, ( int ) strlen( msg ))) < 0 )
			printf( "error sending message: %i\n", ret );
		/* Verbindung schlieen */
		shutdown( s, 2 );
		sclose( s );
	}
}